Subject: [Suit] Uninstalling a SUIT manifest'ed component

From: Dave Thaler <[email-masked]>
Date: Thu, 19 Nov 2020 23:59:15 +0000

Currently the SUIT manifest spec talks about the "Update Procedure" for
fetching dependencies and images, and installing them.  The TEEP WG uses
SUIT manifests for installing Trusted Apps, but also needs to be able to
uninstall Trusted Apps on command.

This begs the question of what is the correct "Uninstall" procedure for a component
with a SUIT manifest.   For example, is it

a)      Implied that one can simply delete all files referenced in the SUIT manifest and

the SUIT manifest?  I suspect that might be insufficient in some cases.  E.g., if

a SUIT manifest processor creates a Security Domain, is it always deleted if you

delete the last component in it?  Or should deletion be explicit?  Controlling

the answer to that question would require, I think, a SUIT manifest.

b)     Possible to create a SUIT manifest that when processed simply deletes

a component?  E.g., bump the manifest version number, keep the component id,

and use empty payload and whatever commands are needed to clean up

whatever state is needed?

c)      Something else?

Currently the SUIT manifest draft doesn't say, and I think it should so we can reference
the answer from the TEEP protocol spec.  If we have time, we might discuss this
in the SUIT meeting, but wanted to at least post the question to the list first.

Dave